						 //=========================================================================================================================================
#include <string.h>
#include "ads7843drv.h"

//averaging value
int prec = 20;

//====================================================================================
void Delayus( int k)
{
    int j;
    for(j=k;j > 0;j--);    
}
//====================================================================================
void TP_Init(void)
{
  // IODIR1 = 0x00;
 //  IODIR1 = IODIR1 | MASK_CS | MASK_DCLK | MASK_DIN;
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB|RCC_APB2Periph_GPIOG,  ENABLE);
  GPIO_InitTypeDef GPIO_InitStructure;
       GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_15|GPIO_Pin_13|GPIO_Pin_12;
       GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;                 //
       GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
       GPIO_Init(GPIOB, &GPIO_InitStructure);

       GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_7 ;
       GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
       GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU ;
       GPIO_Init(GPIOG, &GPIO_InitStructure);
       //Read_X();
}
//====================================================================================
static void WR_CMD (unsigned char cmd) 
{
    unsigned char buf;
    unsigned char i;
    TP_CS(1);
    TP_DIN(0);
    TP_DCLK(0);
    TP_CS(0);
    for(i=0;i<8;i++) 
    {
        buf=(cmd>>(7-i))&0x1;
        TP_DIN(buf);
        Delayus(5);
        TP_DCLK(1);
        Delayus(5);
        TP_DCLK(0);
    }
}
//====================================================================================
static unsigned short RD_AD(void) 
{
    unsigned short buf=0,temp;
    unsigned char i;
    TP_DIN(0);
    TP_DCLK(1);
    for(i=0;i<12;i++) 
    {
        Delayus(5);
        TP_DCLK(0);         
        Delayus(5);   
        temp= (TP_DOUT) ? 1:0;
        buf|=(temp<<(11-i));
        
        Delayus(5);
        TP_DCLK(1);
    }
    TP_CS(1);
    buf&=0x0fff;
    return(buf);
}
//====================================================================================
int Read_X(void) 
{ 
    int i;
    WR_CMD(CHX);
   // while(TP_BUSY);
    Delayus(10); //changed from 5
    i=RD_AD();
    return i;   
}
//====================================================================================
int Read_Y(void) 
{ 
    int i;
    WR_CMD(CHY);
    //while(TP_BUSY);
    Delayus(10);//changed from 5
    i=RD_AD();
    return i;    
}
//====================================================================================
void TP_GetAdXY(uint16_t *x, uint16_t *y) //reads touch screen ADC value
{
    uint16_t adx,ady;
    adx=Read_X();
    ady=Read_Y();
    *x=adx;
    *y=ady;
}


//reading adc values and averaging
void TP_GetAVGAdXY(uint32_t *x, uint32_t *y)
{
 uint32_t adx = 0;
  uint32_t ady = 0;
  int i;
  //let it settle
  Delayus(10);
  //first garbage read
  i=Read_X();
  i=Read_Y();
  for (i=0; i<prec; i++)
    {
      adx +=Read_X();
      ady +=Read_Y();
    }
  *x= (uint16_t)adx/prec;
  *y= (uint16_t)ady/prec;
}

void TP_GetMedianAdXY(uint32_t *x, uint32_t *y)
{
   uint32_t madx[MEDIAN];
   uint32_t mady[MEDIAN];
   int i;

   for (i=0; i<MEDIAN; i++)
     {
       TP_GetAVGAdXY(&madx[i],  &mady[i]);
     }
   *x= median(madx);
   *y= median(mady);
}

int median(uint32_t x[]) {
    uint32_t temp;
    int i, j;
    // the following two loops sort the array x in ascending order
    for(i=0; i<MEDIAN-1; i++) {
        for(j=i+1; j<MEDIAN; j++) {
            if(x[j] < x[i]) {
                // swap elements
                temp = x[i];
                x[i] = x[j];
                x[j] = temp;
            }
        }
    }

    if(MEDIAN%2==0) {
        // if there is an even number of elements, return mean of the two elements in the middle
        return((x[MEDIAN/2] + x[MEDIAN/2 - 1]) / 2.0);
    } else {
        // else return the element in the middle
        return x[MEDIAN/2];
    }
}



void TP_GetXY(uint32_t *x, uint32_t *y)
{
uint32_t TP_X, TP_Y;
TP_GetMedianAdXY(&TP_Y, &TP_X);
*x = ((TP_X-PixOffsX)/PixSizeX);
*y = ((TP_Y-PixOffsY)/PixSizeY);
if (*x < 0)
  *x = 0;
if (*y < 0)
  *y = 0;
}

